// 
const scrollCheck = document.querySelector("#scroll-check");
const keyboardCheck = document.querySelector("#keyboard-check");

document.addEventListener("keydown", function (e) {
    if (keyboardCheck.checked && e.ctrlKey &&
        (
            e.keyCode == "61" ||
            e.keyCode == "107" ||
            e.keyCode == "173" ||
            e.keyCode == "109" ||
            e.keyCode == "187" ||
            e.keyCode == "189"
        )
    ) {
        e.preventDefault();
    }
});
document.addEventListener(
    "wheel",
    function (e) {
        if (scrollCheck.checked && e.ctrlKey) {
            e.preventDefault();
        }
    },
    {
        passive: false
    }
);

$(document).ready(function () {
    if ($('.home_banner').length) {
        $(this).scrollTop(0);
    }
    match_height();
});

function match_height() {
    if ($('.match_height_div2').length) {
        $('.match_height_div2').matchHeight();
    }

    if ($('.match_height_div').length) {
        $('.match_height_div').matchHeight();
    }

    if ($('.match_height_col').length) {
        $('.match_height_col').matchHeight();
    }

    if ($('.match_height_txt').length) {
        $('.match_height_txt').matchHeight();
    }
    if ($('.match_height_img').length) {
        $('.match_height_img').matchHeight();
    }

}

//slider_area_one
if ($('#slide').length) {
    $('#slide').owlCarousel({
        center: true,
        loop: true,
        autoplay: true,
        autoplayTimeout: 1000,
        autoplaySpeed: 1000,
        margin: 0,
        nav: false,
        dots: false,
        // stagePadding: 20,
        navText: ["<i class='far fa-angle-left'></i>", "<i class='far fa-angle-right'></i>"],
        responsive: {
            0: {
                items: 2
            },
            567: {
                items: 2
            },
            768: {
                items: 3
            },
            1000: {
                items: 4.2
            }
        }
    });
}

//slider_area_one
if ($('#slide_two').length) {
    $('#slide_two').owlCarousel({
        rtl: true,
        center: true,
        loop: true,
        autoplay: true,
        autoplayTimeout: 1000,
        autoplaySpeed: 1000,
        margin: 0,
        nav: false,
        dots: false,
        // stagePadding: 20,
        navText: ["<i class='far fa-angle-left'></i>", "<i class='far fa-angle-right'></i>"],
        responsive: {
            0: {
                items: 2
            },
            567: {
                items: 2
            },
            768: {
                items: 3
            },
            1000: {
                items: 4.2
            }
        }
    });
}

if ($('#scroll').length) {
    $('#scroll').owlCarousel({
        // center: true,
        loop: true,
        autoplay: true,
        autoplayTimeout: 5000,
        autoplaySpeed: 2000,
        margin: 0,
        nav: false,
        dots: false,
        // stagePadding: 20,
        navText: ["<i class='far fa-angle-left'></i>", "<i class='far fa-angle-right'></i>"],
        responsive: {
            0: {
                items: 1
            },
            567: {
                items: 2
            },
            768: {
                items: 3
            },
            1000: {
                items: 3
            }
        }
    });
}


if ($('.circle_percent').length) {
    $(".circle_percent").each(function () {
        var $this = $(this),
            $dataV = $this.data("percent"),
            $dataDeg = $dataV * 3.6,
            $round = $this.find(".round_per");
        $round.css("transform", "rotate(" + parseInt($dataDeg + 180) + "deg)");
        $this.append('<div class="circle_inbox"><span class="percent_text"></span></div>');
        $this.prop('Counter', 0).animate({ Counter: $dataV },
            {
                duration: 2000,
                easing: 'swing',
                step: function (now) {
                    $this.find(".percent_text").text(Math.ceil(now) + "%");
                }
            });
        if ($dataV >= 51) {
            $round.css("transform", "rotate(" + 360 + "deg)");
            setTimeout(function () {
                $this.addClass("percent_more");
            }, 1000);
            setTimeout(function () {
                $round.css("transform", "rotate(" + parseInt($dataDeg + 180) + "deg)");
            }, 1000);
        }
    });
}


$('body').on('click', '.open_mobile_menu', function () {
    $('.open_menu').addClass('show_open');
    $('body').addClass('scroll_off');
});
$('body').on('click', '.open_menu .cross_menu', function () {
    $('.open_menu.show_open').removeClass('show_open');
    $('body').removeClass('scroll_off');
});

document.addEventListener("DOMContentLoaded", function () {
    document.querySelectorAll('.inner_sidebar ul li a').forEach(function (element) {
        element.addEventListener('click', function (e) {
            let nextEl = element.nextElementSibling;
            let parentEl = element.parentElement;
            if (nextEl) {
                e.preventDefault();
                let mycollapse = new bootstrap.Collapse(nextEl);
                if (nextEl.classList.contains('show')) {
                    mycollapse.hide();
                }
                else {
                    mycollapse.show();
                    // find other submenus with class=show
                    var opened_submenu = parentEl.parentElement.querySelector('.submenu.show');
                    // if it exists, then close all of them
                    if (opened_submenu) {
                        new bootstrap.Collapse(opened_submenu);
                    }
                }
            }
        }); // addEventListener
    }) // forEach
});

$('body').on('click', '.header_section .header_area .search_icon', function () {
    $('.form_open').addClass('form_open_show');
    //$('body').addClass('scroll_off');
});

$('body').on('click', '.form_open .inner_form .close .btn', function () {

    $('.form_open form').trigger('reset');
    $('.form_open').removeClass('form_open_show');
    //$('body').removeClass('scroll_off');
});


function progress_bar_counter1(progressBar1, progressText1) {
    var i1 = 0;
    function customProgressBar1() {
        progressWidth1 = $('#' + progressBar1).attr('data-width');
        if (i1 == 0) {
            i1 = 1;
            var progressBarWidth1 = document.getElementById(progressBar1);
            var progressBarText2 = document.getElementById(progressText1);
            var width1 = 0;
            var id1 = setInterval(frame1, 20);
            function frame1() {
                if (width1 >= progressWidth1) {
                    clearInterval(id1);
                    i1 = 0;
                }
                else {
                    width1++;
                    progressBarWidth1.style.width = width1 + "%";
                    progressBarText2.innerHTML = width1 + "%";
                }
            }
        }
    }
    customProgressBar1();
}


function progress_bar_counter2(progressBar2, progressText2) {
    var i2 = 0;
    function customProgressBar2() {
        progressWidth2 = $('#' + progressBar2).attr('data-width');
        if (i2 == 0) {
            i2 = 1;
            var progressBarWidth2 = document.getElementById(progressBar2);
            var progressBarText2 = document.getElementById(progressText2);
            var width2 = 0;
            var id2 = setInterval(frame2, 20);
            function frame2() {
                if (width2 >= progressWidth2) {
                    clearInterval(id2);
                    i2 = 0;
                }
                else {
                    width2++;
                    progressBarWidth2.style.width = width2 + "%";
                    progressBarText2.innerHTML = width2 + "%";
                }
            }
        }
    }
    customProgressBar2();
}


function progress_bar_counter3(progressBar3, progressText3) {
    var i3 = 0;
    function customProgressBar3() {
        progressWidth3 = $('#' + progressBar3).attr('data-width');
        if (i3 == 0) {
            i3 = 1;
            var progressBarWidth3 = document.getElementById(progressBar3);
            var progressBarText3 = document.getElementById(progressText3);
            var width3 = 0;
            var id3 = setInterval(frame3, 20);
            function frame3() {
                if (width3 >= progressWidth3) {
                    clearInterval(id3);
                    i3 = 0;
                }
                else {
                    width3++;
                    progressBarWidth3.style.width = width3 + "%";
                    progressBarText3.innerHTML = width3 + "%";
                }
            }
        }
    }
    customProgressBar3();
}



var width = $(document).width();
if (width >= 1024) {
    windowHeight = $(window).height();
    headerInnerHeight = $('.header_section').innerHeight();
    $('body').css({ 'margin-top': (headerInnerHeight) + 'px' });
    $('.banner_section').css({ 'height': (windowHeight - headerInnerHeight) + 'px' });
}
else {
    windowHeight = $(window).height();
    headerInnerHeight = $('.header_section').innerHeight();
    $('body').css({ 'margin-top': (headerInnerHeight) + 'px' });
}

if (width >= 768) {
    let observer = new IntersectionObserver(function (entries) {
        var ele = entries.filter(entry => entry.isIntersecting);
        if (ele.length > 0) {
            ele = ele[0].target;
            if (ele.id == 'page5') {
                progress_bar_counter1('progess1', 'progess1text');
                progress_bar_counter2('progess2', 'progess2text');
                progress_bar_counter3('progess3', 'progess3text');
            }
            //console.log('Visible element is now: ' + ele.id);
        }
    });

    document.querySelectorAll('body [id^=page]').forEach(ele => observer.observe(ele));
}
else {
    let observer = new IntersectionObserver(function (entries) {
        var ele = entries.filter(entry => entry.isIntersecting);
        if (ele.length > 0) {
            ele = ele[0].target;
            if (ele.id == 'pageprogresslist') {
                progress_bar_counter1('progess1', 'progess1text');
                progress_bar_counter2('progess2', 'progess2text');
                progress_bar_counter3('progess3', 'progess3text');
            }
            //console.log('Visible element is now: ' + ele.id);
        }
    });

    document.querySelectorAll('body [id^=page]').forEach(ele => observer.observe(ele));
}


// about us
if ($('.challenge_section').length) {
    $('.challenge_section .challenge_area .card_challenge_area').hover(function () {
        $('.challenge_section .challenge_area .card_challenge_area.active').removeClass('active');
        $(this).addClass('active');
    });
}

if ($('.info_card_section').length) {
    $('.info_card_section .info_card_area .card_main_area').hover(function () {
        $('.info_card_section .info_card_area .card_main_area.active').removeClass('active');
        $(this).addClass('active');
    });
}

if ($('.partner_img_section').length) {
    $('.partner_img_section .img_main_area .owl-carousel .item .img_area_one').hover(function () {
        $('.partner_img_section .img_main_area .owl-carousel .item .img_area_one.active').removeClass('active');
        $(this).addClass('active');
    });
}

if ($('#datepicker').length) {
    $(function () {
        $("#datepicker").datepicker();
    });
}


// Confirm Delete
if ($('._delete_confirm').length) {
    $('body').on('click', '._delete_confirm', function (e) {
        e.preventDefault();
        that = $(this);
        action_type = that.attr('data-type');

        if (action_type == 'order') {
            messageText = 'Are You Sure Want to Cancel This Order?';
        }
        else {
            messageText = 'Are you sure to delete this record?';
        }

        bootbox.confirm({
            message: '<div class="icon_box"><div class="inner_icon_box"><i class="fal fa-trash-alt"></i></div></div><p>' + messageText + '</p>',
            buttons: {
                confirm: {
                    label: 'Yes',
                    className: 'btn-primary left_btn'
                },
                cancel: {
                    label: 'No',
                    className: 'btn-success right_btn'
                }
            },
            callback: function (result) {
                if (result) {
                    return true;
                }
            }
        })
    });
}


//InfoGraphic
// $(document).ready(function () {
//     var bubbleList = $('.bubble-container');
//     const bubbleCount = bubbleList.length;
//     const degStep = -180 / (bubbleCount - 1);

//     $('.bubble-container').each((index) => {
//         const deg = index * degStep;
//         const invertDeg = deg * -1;

//         $(bubbleList[index]).css('transform', `rotate(${deg}deg)`);
//         $(bubbleList[index]).css('opacity', `1`);
//         $(bubbleList[index]).find('.bubble').css('transform', `rotate(${invertDeg}deg)`);
//     })
// })

function focus_on_input() {
    $('.date_icon').click(function () {
        that = $(this);
        parent = that.parents('.form-group');
        parent.find('input').focus();
    });
}

focus_on_input();


// Create Order
//plus minus
$(document).ready(function () {
    $('.minus').click(function () {
        var $input = $(this).parent().find('input');
        var count = parseInt($input.val()) - 1;
        count = count < 1 ? 1 : count;
        $input.val(count);
        $input.change();
        return false;
    });
    $('.plus').click(function () {
        var $input = $(this).parent().find('input');
        $input.val(parseInt($input.val()) + 1);
        $input.change();
        return false;
    });
});

var lastScrollTop = 0;
$(window).scroll(function (event) {
    var st = $(this).scrollTop();
    if (st == 0) {
        $('.header_section').removeClass('scrolling_down');
        $('.header_section').removeClass('scrolling_up');
    }
    else if (st > lastScrollTop) {
        $('.header_section').addClass('scrolling_down');
        $('.header_section').removeClass('scrolling_up');
    }
    else {
        $('.header_section').addClass('scrolling_up');
        $('.header_section').removeClass('scrolling_down');
    }
    lastScrollTop = st;
});